import { useSlots as xt, computed as p, ref as d, onMounted as Qe, onBeforeUnmount as $t, watch as Ze, createElementBlock as n, openBlock as u, unref as r, normalizeStyle as _, normalizeClass as pe, createBlock as E, createCommentVNode as i, renderSlot as g, createElementVNode as f, createVNode as ge, createSlots as et, withCtx as $, normalizeProps as Q, guardReactiveProps as Z, Fragment as m, renderList as T, mergeProps as tt, toDisplayString as P, createTextVNode as lt, nextTick as Ct } from "vue";
import { u as Pt, o as Ft, e as at, g as St, c as Lt, b as Tt, d as ot, p as H, m as zt, Y as At, f as N, X as Ot, s as oe, w as Nt, j as Yt, L as z, i as M, k as ue, n as w, t as Xt, a as It, q as Mt, r as Dt, x as Vt } from "./index-Cq9SFWKh.js";
import { t as Bt, u as Gt } from "./useResponsive-Cw4oZ8sQ.js";
import { _ as Rt } from "./Title-9xdQbKmK.js";
import { u as Ut, U as Wt } from "./usePrinter-Ca40kS6V.js";
import { D as jt } from "./DataTable-BEgGQ4D3.js";
import { _ as Et } from "./Tooltip-DAG_w755.js";
import { L as Ht } from "./Legend-D3fzSDzv.js";
import qt from "./vue-ui-skeleton-CEUPs326.js";
import Jt from "./vue-ui-accordion-DqMoC-KV.js";
import { u as ut } from "./useNestedProp-D3PTIhO4.js";
import { _ as Kt } from "./PackageVersion-BtYm4WhX.js";
import { _ as Qt } from "./PenAndPaper-C0mD6paN.js";
import { u as Zt } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as el } from "./Shape-BlXVxC09.js";
import { u as tl } from "./useChartAccessibility-BWojgys7.js";
import { _ as ll } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const al = ["id"], ol = ["xmlns", "viewBox"], ul = ["width", "height"], sl = { key: 1 }, nl = ["id"], rl = ["stop-color"], il = ["offset", "stop-color"], vl = ["offset", "stop-color"], cl = ["stop-color"], dl = { key: 2 }, hl = ["id", "cx", "cy"], yl = ["stop-color", "stop-opacity"], fl = ["stop-color"], pl = ["id"], gl = ["id"], ml = ["id"], bl = ["flood-color"], wl = ["id"], kl = ["flood-color"], _l = ["d", "stroke", "filter"], xl = ["x1", "y1", "x2", "y2", "stroke", "filter"], $l = ["cx", "cy", "r", "fill", "filter"], Cl = { key: 6 }, Pl = ["stroke", "d"], Fl = { key: 0 }, Sl = ["d", "fill", "stroke", "stroke-width", "filter"], Ll = ["d", "fill", "stroke", "stroke-width", "filter"], Tl = { key: 0 }, zl = ["stroke", "d"], Al = { key: 0 }, Ol = ["d", "stroke", "stroke-width", "filter"], Nl = { key: 1 }, Yl = ["d", "fill", "stroke", "stroke-width", "filter"], Xl = ["d", "fill", "stroke", "stroke-width", "filter"], Il = { key: 1 }, Ml = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Dl = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Vl = ["cx", "cy", "r", "stroke"], Bl = ["cx", "cy", "r", "fill"], Gl = { key: 0 }, Rl = ["d", "fill", "onMouseenter", "onClick"], Ul = { key: 1 }, Wl = ["cx", "cy", "r", "fill"], jl = ["x", "y", "fill", "font-size"], El = ["x", "y", "fill", "font-size"], Hl = ["x", "y", "fill", "font-size"], ql = ["x", "y", "fill", "font-size"], Jl = ["filter"], Kl = { key: 0 }, Ql = ["x", "y"], Zl = { key: 1 }, ea = ["cx", "cy", "fill", "stroke", "filter", "onClick"], ta = ["cx", "cy", "fill", "stroke", "filter", "onClick"], la = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], aa = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], oa = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], ua = ["text-anchor", "x", "y", "fill", "font-size", "onClick"], sa = { key: 2 }, na = ["x", "y", "width"], ra = ["x", "y", "width"], ia = {
  key: 5,
  class: "vue-data-ui-watermark"
}, va = ["onClick"], ca = {
  key: 0,
  style: { "font-variant-numeric": "tabular-nums" }
}, da = { key: 1 }, ha = ["innerHTML"], ya = {
  __name: "vue-ui-donut",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(me, { expose: st, emit: nt }) {
    const { vue_ui_donut: rt } = Pt(), it = xt(), A = me, ee = p({
      get() {
        return !!A.dataset && A.dataset.length;
      },
      set(l) {
        return l;
      }
    }), te = d(null), be = d(null), we = d(null), se = d(null), ke = d(null), _e = d(null), xe = d(0), $e = d(0), Ce = d(0);
    Qe(() => {
      Pe();
    }), $t(() => {
      se.value && se.value.disconnect();
    });
    function Pe() {
      if (Ft(A.dataset) ? at({
        componentName: "VueUiDonut",
        type: "dataset"
      }) : A.dataset.forEach((l, o) => {
        St({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          ee.value = !1, at({
            componentName: "VueUiDonut",
            type: "datasetSerieAttribute",
            property: t,
            index: o
          });
        });
      }), e.value.responsive) {
        const l = Bt(() => {
          const { width: o, height: t } = Gt({
            chart: te.value,
            title: e.value.style.chart.title.text ? be.value : null,
            legend: e.value.style.chart.legend.show ? we.value : null,
            source: ke.value,
            noTitle: _e.value,
            padding: ze.value
          });
          requestAnimationFrame(() => {
            s.value.width = o, s.value.height = t;
          });
        });
        se.value = new ResizeObserver(l), se.value.observe(te.value.parentNode);
      }
    }
    const y = d(Lt()), vt = d(null), ne = d(!1), ve = d(""), F = d(null), Fe = d(0);
    function Se() {
      const l = ut({
        userConfig: A.config,
        defaultConfig: rt
      });
      return l.theme ? {
        ...ut({
          userConfig: It.vue_ui_donut[l.theme] || A.config,
          defaultConfig: l
        }),
        customPalette: Xt[l.theme] || H
      } : l;
    }
    const e = p({
      get: () => Se(),
      set: (l) => l
    }), Y = d(!0), V = d([]);
    function ct(l) {
      return 1 - Math.pow(1 - l, 3);
    }
    function dt(l, o = 1e3, t = 50) {
      return new Promise((a) => {
        const v = l.length;
        V.value = Array(v).fill(0);
        let b = 0;
        l.forEach((k, C) => {
          setTimeout(() => {
            const ae = performance.now();
            function Je(kt) {
              const Ke = Math.min((kt - ae) / o, 1), _t = ct(Ke);
              V.value[C] = k * _t, V.value = [...V.value], Ke < 1 ? requestAnimationFrame(Je) : (V.value[C] = k, V.value = [...V.value], b += 1, b === v && a());
            }
            requestAnimationFrame(Je);
          }, C * t);
        });
      });
    }
    Qe(async () => {
      const l = A.dataset.map((o) => o.values.reduce((t, a) => t + a, 0));
      e.value.startAnimation.show && await dt(
        l,
        e.value.startAnimation.durationMs,
        e.value.startAnimation.staggerMs
      ), Y.value = !1;
    });
    const { userOptionsVisible: ce, setUserOptionsVisibility: Le, keepUserOptionState: Te } = Zt({ config: e.value }), { svgRef: de } = tl({ config: e.value.style.chart.title });
    Ze(() => A.config, (l) => {
      e.value = Se(), ce.value = !e.value.userOptions.showOnChartHover, Pe(), xe.value += 1, $e.value += 1, Ce.value += 1, h.value.dataLabels.show = e.value.style.chart.layout.labels.dataLabels.show, h.value.showTable = e.value.table.show, h.value.showTooltip = e.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const ze = p(() => {
      const { top: l, right: o, bottom: t, left: a } = e.value.style.chart.padding;
      return {
        css: `padding:${l}px ${o}px ${t}px ${a}px`,
        top: l,
        right: o,
        bottom: t,
        left: a
      };
    }), { isPrinting: Ae, isImaging: Oe, generatePdf: Ne, generateImage: Ye } = Ut({
      elementId: `donut__${y.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-donut",
      options: e.value.userOptions.print
    }), ht = p(() => e.value.userOptions.show && !e.value.style.chart.title.text), Xe = p(() => Tt(e.value.customPalette)), h = d({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), s = d({
      height: 360,
      width: 512
    }), q = p(() => {
      const l = e.value.style.chart.layout.donut.strokeWidth / 512, o = Math.min(s.value.width, s.value.height) * l, t = o > x.value ? x.value : o;
      return Math.max(t, 3);
    }), Ie = nt, B = p(() => A.dataset.map((l, o) => ({
      name: l.name,
      color: ot(l.color) || Xe.value[o] || H[o] || H[o % H.length],
      value: l.values.reduce((t, a) => t + a, 0),
      absoluteValues: l.values,
      comment: l.comment || "",
      patternIndex: o,
      seriesIndex: o,
      ghost: !1,
      pattern: `pattern_${y.value}_${o}`
    }))), O = d(B.value);
    Ze(() => B.value, (l) => O.value = l);
    function yt() {
      return B.value.map((l) => ({
        name: l.name,
        color: l.color,
        value: l.value
      }));
    }
    const D = d([]), Me = d(null), De = d(null), W = d(!1);
    function Ve(l) {
      const o = B.value.find((v, b) => b === l), t = O.value.find((v, b) => b === l);
      let a = t.value;
      if (D.value.includes(l)) {
        let b = function() {
          O.value = O.value.map((C, ae) => l === ae ? {
            ...C,
            value: v
          } : C);
        }, k = function() {
          a > v ? (cancelAnimationFrame(Me.value), b(), W.value = !1) : (W.value = !0, a += v * (e.value.type === "polar" ? 1 : 0.045), O.value = O.value.map((C, ae) => l === ae ? {
            ...C,
            value: a
          } : C), Me.value = requestAnimationFrame(k));
        };
        D.value = D.value.filter((C) => C !== l);
        const v = o.value;
        e.value.useSerieToggleAnimation ? k() : b();
      } else if (D.value.length < B.value.length - 1) {
        let v = function() {
          D.value.push(l), O.value = O.value.map((k, C) => l === C ? {
            ...k,
            value: 0
          } : k);
        }, b = function() {
          a < t.value / 100 ? (cancelAnimationFrame(De.value), v(), W.value = !1) : (W.value = !0, a /= e.value.type === "polar" ? 20 : 1.18, O.value = O.value.map((k, C) => l === C ? {
            ...k,
            value: a
          } : k), De.value = requestAnimationFrame(b));
        };
        e.value.useSerieToggleAnimation ? b() : v();
      }
      Ie("selectLegend", G.value.map((v) => ({
        name: v.name,
        color: v.color,
        value: v.value
      })));
    }
    const ft = p(() => A.dataset.reduce((l, o) => l + o.values.reduce((t, a) => t + a, 0), 0)), G = p(() => {
      if (Y.value) {
        const l = V.value.map((t, a) => ({
          ...B.value[a],
          value: t,
          color: B.value[a].color,
          ghost: !1
        })), o = ft.value - V.value.reduce((t, a) => t + a, 0);
        return o > 0 && l.push({
          name: "__ghost__",
          value: o,
          color: "transparent",
          ghost: !0
        }), l;
      } else
        return O.value.forEach((l, o) => {
          if ([null, void 0].includes(l.values))
            return {
              ...l,
              values: []
            };
        }), O.value.map((l, o) => ({
          ...l,
          seriesIndex: o
        })).filter((l, o) => !D.value.includes(o));
    }), Be = p(() => A.dataset.map((l, o) => ({
      name: l.name,
      color: ot(l.color) || Xe.value[o] || H[o] || H[o % H.length],
      value: (l.values || []).reduce((t, a) => t + a, 0),
      shape: "circle",
      patternIndex: o
    })).map((l, o) => ({
      ...l,
      proportion: l.value / A.dataset.map((t) => (t.values || []).reduce((a, v) => a + v, 0)).reduce((t, a) => t + a, 0),
      opacity: D.value.includes(o) ? 0.5 : 1,
      segregate: () => !W.value && Ve(o),
      isSegregated: D.value.includes(o)
    }))), pt = p(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), x = p(() => {
      const l = Math.min(s.value.width / 3, s.value.height / 3);
      return l < 55 ? 55 : l;
    }), S = p(() => zt({ series: G.value }, s.value.width / 2, s.value.height / 2, x.value, x.value, 1.99999, 2, 1, 360, 105.25, q.value)), X = p(() => S.value.filter((l) => !l.ghost)), c = p(() => {
      const l = Math.max(...G.value.map((t) => t.value)), o = G.value.map((t) => t.value / l);
      return At({
        series: o,
        center: {
          x: s.value.width / 2,
          y: s.value.height / 2
        },
        maxRadius: Math.min(s.value.width, s.value.height) / 3,
        hasGhost: Y.value
      });
    });
    function J(l) {
      return l.x > s.value.width / 2 + 6 ? "start" : l.x < s.value.width / 2 - 6 ? "end" : "middle";
    }
    function gt(l) {
      return l.middlePoint.y > s.value.height / 2 ? z({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 100, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y : z({ initX: l.middlePoint.x, initY: l.middlePoint.y, offset: 0, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y - 100;
    }
    function I(l) {
      return l.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function he(l, o) {
      const t = l.value / mt(o);
      return isNaN(t) ? 0 : M(
        e.value.style.chart.layout.labels.percentage.formatter,
        t * 100,
        N({
          v: t * 100,
          s: "%",
          r: e.value.style.chart.layout.labels.percentage.rounding
        }),
        { datapoint: l }
      );
    }
    function mt(l) {
      return [...l].map((o) => o.value).reduce((o, t) => o + t, 0);
    }
    const L = p(() => G.value.map((l) => l.value).reduce((l, o) => l + o, 0)), Ge = p(() => L.value / G.value.length), Re = p(() => (l) => W.value ? l.proportion * 100 : l.value / L.value * 100), ye = d(null), le = d(!1);
    function Ue({ datapoint: l, relativeIndex: o, seriesIndex: t, show: a = !1 }) {
      ye.value = { datapoint: l, seriesIndex: t, config: e.value, series: B.value }, ne.value = a, F.value = o;
      let v = "";
      const b = e.value.style.chart.tooltip.customFormat;
      if (le.value = !1, Vt(b))
        try {
          const k = b({
            seriesIndex: t,
            datapoint: l,
            series: B.value,
            config: e.value
          });
          typeof k == "string" && (ve.value = k, le.value = !0);
        } catch {
          console.warn("Custom format cannot be applied."), le.value = !1;
        }
      if (!le.value) {
        if (v += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${l.name}</div>`, v += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 60 60" height="14" width="14"><circle cx="30" cy="30" r="30" stroke="none" fill="${l.color}"/>${it.pattern ? `<circle cx="30" cy="30" r="30" stroke="none" fill="url(#pattern_${y.value}_${t})"/>` : ""}</svg>`, e.value.style.chart.tooltip.showValue && (v += `<b>${M(
          e.value.style.chart.layout.labels.value.formatter,
          l.value,
          N({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: l.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: l,
            relativeIndex: o,
            seriesIndex: t
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const k = M(
            e.value.style.chart.layout.labels.percentage.formatter,
            l.proportion * 100,
            N({
              v: l.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            }),
            {
              datapoint: l,
              relativeIndex: o,
              seriesIndex: t
            }
          );
          e.value.style.chart.tooltip.showValue ? v += `<span>(${k})</span></div>` : v += `<b>${k}</b></div>`;
        }
        e.value.style.chart.comments.showInTooltip && l.comment && (v += `<div class="vue-data-ui-tooltip-comment" style="background:${l.color}20; padding: 6px; margin-bottom: 6px; margin-top:6px; border-left: 1px solid ${l.color}">${l.comment}</div>`), ve.value = `<div>${v}</div>`;
      }
    }
    function j(l) {
      return e.value.useBlurOnHover && ![null, void 0].includes(F.value) && F.value !== l ? `url(#blur_${y.value})` : "";
    }
    const R = p(() => {
      const l = G.value.map((t) => ({
        name: t.name,
        color: t.color
      })), o = G.value.map((t) => t.value);
      return { head: l, body: o };
    });
    function We() {
      Ct(() => {
        const l = R.value.head.map((a, v) => [[
          a.name
        ], [R.value.body[v]], [isNaN(R.value.body[v] / L.value) ? "-" : R.value.body[v] / L.value * 100]]), o = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(l), t = Mt(o);
        Dt({ csvContent: t, title: e.value.style.chart.title.text || "vue-ui-donut" });
      });
    }
    const re = p(() => {
      const l = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        N({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: L.value, s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue }),
        "100%"
      ], o = R.value.head.map((v, b) => [
        {
          color: v.color,
          name: v.name
        },
        R.value.body[b],
        isNaN(R.value.body[b] / L.value) ? "-" : (R.value.body[b] / L.value * 100).toFixed(e.value.table.td.roundingPercentage) + "%"
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: l,
        body: o,
        config: t
      };
    }), K = d(!1);
    function bt(l) {
      K.value = l, Fe.value += 1;
    }
    const je = p(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent));
    function wt(l) {
      return l.toFixed(e.value.style.chart.legend.roundingPercentage).split("").map((o) => "-").join("");
    }
    function U(l, o) {
      Ie("selectDatapoint", { datapoint: l, index: o });
    }
    function Ee() {
      h.value.showTable = !h.value.showTable;
    }
    function He() {
      h.value.dataLabels.show = !h.value.dataLabels.show;
    }
    function qe() {
      h.value.showTooltip = !h.value.showTooltip;
    }
    const ie = d(!1);
    function fe() {
      ie.value = !ie.value;
    }
    return st({
      getData: yt,
      generatePdf: Ne,
      generateCsv: We,
      generateImage: Ye,
      toggleTable: Ee,
      toggleLabels: He,
      toggleTooltip: qe,
      toggleAnnotator: fe
    }), (l, o) => (u(), n("div", {
      ref_key: "donutChart",
      ref: te,
      class: pe(`vue-ui-donut ${K.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: _(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height:100%;" : ""} text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `donut__${y.value}`,
      onMouseenter: o[6] || (o[6] = () => r(Le)(!0)),
      onMouseleave: o[7] || (o[7] = () => r(Le)(!1))
    }, [
      e.value.userOptions.buttons.annotator && r(de) ? (u(), E(Qt, {
        key: 0,
        color: e.value.style.chart.color,
        backgroundColor: e.value.style.chart.backgroundColor,
        active: ie.value,
        svgRef: r(de),
        onClose: fe
      }, null, 8, ["color", "backgroundColor", "active", "svgRef"])) : i("", !0),
      g(l.$slots, "userConfig", {}, void 0, !0),
      ht.value ? (u(), n("div", {
        key: 1,
        ref_key: "noTitle",
        ref: _e,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : i("", !0),
      e.value.style.chart.title.text ? (u(), n("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: be,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (u(), E(Rt, {
          key: `title_${xe.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : i("", !0),
      e.value.userOptions.show && ee.value && (r(Te) || r(ce)) ? (u(), E(Wt, {
        ref_key: "details",
        ref: vt,
        key: `user_option_${Fe.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: r(Ae),
        isImaging: r(Oe),
        uid: y.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: K.value,
        chartElement: te.value,
        position: e.value.userOptions.position,
        isTooltip: h.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: ie.value,
        onToggleFullscreen: bt,
        onGeneratePdf: r(Ne),
        onGenerateCsv: We,
        onGenerateImage: r(Ye),
        onToggleTable: Ee,
        onToggleLabels: He,
        onToggleTooltip: qe,
        onToggleAnnotator: fe,
        style: _({
          visibility: r(Te) ? r(ce) ? "visible" : "hidden" : "visible"
        })
      }, et({ _: 2 }, [
        l.$slots.menuIcon ? {
          name: "menuIcon",
          fn: $(({ isOpen: t, color: a }) => [
            g(l.$slots, "menuIcon", Q(Z({ isOpen: t, color: a })), void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: $(() => [
            g(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: $(() => [
            g(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: $(() => [
            g(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: $(() => [
            g(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: $(() => [
            g(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        l.$slots.optionLabels ? {
          name: "optionLabels",
          fn: $(() => [
            g(l.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "6"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: $(({ toggleFullscreen: t, isFullscreen: a }) => [
            g(l.$slots, "optionFullscreen", Q(Z({ toggleFullscreen: t, isFullscreen: a })), void 0, !0)
          ]),
          key: "7"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: $(({ toggleAnnotator: t, isAnnotator: a }) => [
            g(l.$slots, "optionAnnotator", Q(Z({ toggleAnnotator: t, isAnnotator: a })), void 0, !0)
          ]),
          key: "8"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : i("", !0),
      ee.value ? (u(), n("svg", {
        key: 4,
        ref_key: "svgRef",
        ref: de,
        xmlns: r(Ot),
        class: pe({ "vue-data-ui-fullscreen--on": K.value, "vue-data-ui-fulscreen--off": !K.value }),
        viewBox: `0 0 ${s.value.width <= 0 ? 10 : s.value.width} ${s.value.height <= 0 ? 10 : s.value.height}`,
        style: _(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color};${ze.value.css}`)
      }, [
        ge(Kt),
        l.$slots["chart-background"] ? (u(), n("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: s.value.width <= 0 ? 10 : s.value.width,
          height: s.value.height <= 0 ? 10 : s.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          g(l.$slots, "chart-background", {}, void 0, !0)
        ], 8, ul)) : i("", !0),
        e.value.type === "classic" && !isNaN(q.value / x.value) ? (u(), n("defs", sl, [
          e.value.style.chart.useGradient ? (u(), n("radialGradient", {
            key: 0,
            id: `gradient_${y.value}`
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": r(oe)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, rl),
            f("stop", {
              offset: `${(1 - q.value / x.value) * 100}%`,
              "stop-color": r(oe)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, il),
            f("stop", {
              offset: `${(1 - q.value / x.value / 2) * 100}%`,
              "stop-color": r(oe)("#FFFFFF", e.value.style.chart.gradientIntensity)
            }, null, 8, vl),
            f("stop", {
              offset: "100%",
              "stop-color": r(oe)(e.value.style.chart.backgroundColor, 0),
              "stop-opacity": "0"
            }, null, 8, cl)
          ], 8, nl)) : i("", !0)
        ])) : i("", !0),
        e.value.type === "polar" ? (u(), n("defs", dl, [
          (u(!0), n(m, null, T(c.value, (t, a) => (u(), n("radialGradient", {
            id: `polar_gradient_${a}_${y.value}`,
            cx: (isNaN(t.middlePoint.x / s.value.width * 100) ? 0 : t.middlePoint.x / s.value.width * 100) + "%",
            cy: (isNaN(t.middlePoint.y / s.value.height * 100) ? 0 : t.middlePoint.y / s.value.height * 100) + "%",
            r: "62%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": r(Nt)(S.value[a].color, 0.05),
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, yl),
            f("stop", {
              offset: "100%",
              "stop-color": S.value[a].color
            }, null, 8, fl)
          ], 8, hl))), 256))
        ])) : i("", !0),
        f("defs", null, [
          f("filter", {
            id: `blur_${y.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            f("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${y.value}`
            }, null, 8, gl),
            o[8] || (o[8] = f("feColorMatrix", {
              type: "saturate",
              values: "0"
            }, null, -1))
          ], 8, pl),
          f("filter", {
            id: `shadow_${y.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            f("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, bl)
          ], 8, ml),
          f("filter", {
            id: `drop_shadow_${y.value}`,
            "color-interpolation-filters": "sRGB",
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            f("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "3",
              "flood-opacity": "1",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, kl)
          ], 8, wl)
        ]),
        e.value.type === "classic" ? (u(!0), n(m, { key: 3 }, T(S.value.filter((t) => !t.ghost), (t, a) => (u(), n("g", null, [
          I(t) && h.value.dataLabels.show ? (u(), n("path", {
            key: 0,
            d: r(Yt)(t, { x: s.value.width / 2, y: s.value.height / 2 }, 16, 16, !1, !1, q.value, 12, e.value.style.chart.layout.curvedMarkers),
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: j(a)
          }, null, 8, _l)) : i("", !0)
        ]))), 256)) : i("", !0),
        e.value.type === "polar" ? (u(!0), n(m, { key: 4 }, T(S.value.filter((t) => !t.ghost), (t, a) => (u(), n("g", null, [
          I(t) && h.value.dataLabels.show ? (u(), n("line", {
            key: 0,
            x1: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
            y1: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y,
            x2: c.value[a].middlePoint.x,
            y2: c.value[a].middlePoint.y,
            stroke: t.color,
            "stroke-width": "1",
            "stroke-linecap": "round",
            "stroke-linejoin": "round",
            fill: "none",
            filter: j(a),
            style: _({
              transition: Y.value ? "" : "all 0.1s ease-in-out"
            })
          }, null, 12, xl)) : i("", !0)
        ]))), 256)) : i("", !0),
        e.value.type === "classic" && e.value.style.chart.layout.donut.useShadow ? (u(), n("circle", {
          key: 5,
          cx: s.value.width / 2,
          cy: s.value.height / 2,
          r: x.value <= 0 ? 10 : x.value,
          fill: e.value.style.chart.backgroundColor,
          filter: `url(#shadow_${y.value})`
        }, null, 8, $l)) : i("", !0),
        l.$slots.pattern ? (u(), n("g", Cl, [
          (u(!0), n(m, null, T(me.dataset, (t, a) => (u(), n("defs", {
            key: `pattern-${t.patternIndex}`
          }, [
            g(l.$slots, "pattern", tt({ ref_for: !0 }, { seriesIndex: a, patternId: `pattern_${y.value}_${a}` }), void 0, !0)
          ]))), 128))
        ])) : i("", !0),
        L.value && e.value.type === "classic" ? (u(), n(m, { key: 7 }, [
          (u(!0), n(m, null, T(X.value, (t, a) => (u(), n("path", {
            stroke: e.value.style.chart.backgroundColor,
            d: t.arcSlice,
            fill: "#FFFFFF"
          }, null, 8, Pl))), 256)),
          l.$slots.pattern ? (u(), n("g", Fl, [
            (u(!0), n(m, null, T(X.value, (t, a) => (u(), n("path", {
              class: "vue-ui-donut-arc-path",
              d: t.arcSlice,
              fill: `url(#${t.pattern})`,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: j(a)
            }, null, 8, Sl))), 256))
          ])) : i("", !0),
          (u(!0), n(m, null, T(X.value, (t, a) => (u(), n("path", {
            class: "vue-ui-donut-arc-path",
            d: t.arcSlice,
            fill: r(oe)(t.color, 80),
            stroke: e.value.style.chart.backgroundColor,
            "stroke-width": e.value.style.chart.layout.donut.borderWidth,
            filter: j(a)
          }, null, 8, Ll))), 256))
        ], 64)) : i("", !0),
        L.value && e.value.type === "polar" ? (u(), n(m, { key: 8 }, [
          S.value.length > 1 ? (u(), n("g", Tl, [
            (u(!0), n(m, null, T(X.value, (t, a) => (u(), n("path", {
              stroke: e.value.style.chart.backgroundColor,
              d: c.value[a].path,
              fill: "#FFFFFF",
              style: _({
                transition: Y.value ? "none" : "all 0.1s ease-in-out"
              })
            }, null, 12, zl))), 256)),
            e.value.style.chart.layout.donut.useShadow ? (u(), n("g", Al, [
              (u(!0), n(m, null, T(X.value, (t, a) => (u(), n("path", {
                class: "vue-ui-donut-arc-path",
                d: c.value[a].path,
                fill: "transparent",
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": e.value.style.chart.layout.donut.borderWidth,
                filter: `url(#drop_shadow_${y.value})`,
                style: _({
                  transition: Y.value ? "none" : "all 0.1s ease-in-out"
                })
              }, null, 12, Ol))), 256))
            ])) : i("", !0),
            l.$slots.pattern ? (u(), n("g", Nl, [
              (u(!0), n(m, null, T(X.value, (t, a) => (u(), n("path", {
                class: "vue-ui-donut-arc-path",
                d: c.value[a].path,
                fill: `url(#${t.pattern})`,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": e.value.style.chart.layout.donut.borderWidth,
                filter: j(a),
                style: _({
                  transition: Y.value ? "none" : "all 0.1s ease-in-out"
                })
              }, null, 12, Yl))), 256))
            ])) : i("", !0),
            (u(!0), n(m, null, T(X.value, (t, a) => (u(), n("path", {
              class: "vue-ui-donut-arc-path",
              d: c.value[a].path,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_${a}_${y.value})` : t.color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: j(a),
              style: _({
                transition: Y.value ? "none" : "all 0.1s ease-in-out"
              })
            }, null, 12, Xl))), 256))
          ])) : (u(), n("g", Il, [
            l.$slots.pattern ? (u(), n("circle", {
              key: 0,
              cx: s.value.width / 2,
              cy: s.value.height / 2,
              r: x.value,
              fill: `url(#pattern_${y.value}_${S.value[0].patternIndex})`,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth
            }, null, 8, Ml)) : i("", !0),
            f("circle", {
              cx: s.value.width / 2,
              cy: s.value.height / 2,
              r: x.value,
              fill: e.value.style.chart.useGradient ? `url(#polar_gradient_0_${y.value})` : S.value[0].color,
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth
            }, null, 8, Dl)
          ]))
        ], 64)) : (u(), n("circle", {
          key: 9,
          cx: s.value.width / 2,
          cy: s.value.height / 2,
          r: x.value <= 0 ? 10 : x.value,
          fill: "transparent",
          stroke: e.value.style.chart.backgroundColor
        }, null, 8, Vl)),
        e.value.style.chart.useGradient && e.value.type === "classic" ? (u(), n("circle", {
          key: 10,
          cx: s.value.width / 2,
          cy: s.value.height / 2,
          r: (
            /* This might require adjustments */
            x.value <= 0 ? 10 : x.value
          ),
          fill: `url(#gradient_${y.value})`
        }, null, 8, Bl)) : i("", !0),
        L.value ? (u(), n(m, { key: 11 }, [
          S.value.length > 1 || e.value.type === "classic" ? (u(), n("g", Gl, [
            (u(!0), n(m, null, T(S.value.filter((t) => !t.ghost), (t, a) => (u(), n("path", {
              d: e.value.type === "classic" ? t.arcSlice : c.value[a].path,
              fill: F.value === a ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (v) => Ue({
                datapoint: t,
                relativeIndex: a,
                seriesIndex: t.seriesIndex,
                show: !0
              }),
              onMouseleave: o[0] || (o[0] = (v) => {
                ne.value = !1, F.value = null;
              }),
              onClick: (v) => U(t, a)
            }, null, 40, Rl))), 256))
          ])) : (u(), n("g", Ul, [
            f("circle", {
              cx: s.value.width / 2,
              cy: s.value.height / 2,
              r: x.value,
              fill: F.value === l.i ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: o[1] || (o[1] = (t) => Ue({
                datapoint: S.value[0],
                relativeIndex: 0,
                seriesIndex: S.value[0].seriesIndex,
                show: !0
              })),
              onMouseleave: o[2] || (o[2] = (t) => {
                ne.value = !1, F.value = null;
              }),
              onClick: o[3] || (o[3] = (t) => U(S.value[0], l.i))
            }, null, 40, Wl)
          ]))
        ], 64)) : i("", !0),
        e.value.type === "classic" ? (u(), n(m, { key: 12 }, [
          e.value.style.chart.layout.labels.hollow.total.show ? (u(), n("text", {
            key: 0,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.fontSize,
            style: _(`font-weight:${e.value.style.chart.layout.labels.hollow.total.bold ? "bold" : ""}`)
          }, P(e.value.style.chart.layout.labels.hollow.total.text), 13, jl)) : i("", !0),
          e.value.style.chart.layout.labels.hollow.total.show ? (u(), n("text", {
            key: 1,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 + e.value.style.chart.layout.labels.hollow.total.fontSize - (e.value.style.chart.layout.labels.hollow.average.show ? e.value.style.chart.layout.labels.hollow.total.fontSize : 0) + e.value.style.chart.layout.labels.hollow.total.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.total.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.total.value.fontSize,
            style: _(`font-weight:${e.value.style.chart.layout.labels.hollow.total.value.bold ? "bold" : ""}`)
          }, P(r(M)(
            e.value.style.chart.layout.labels.hollow.total.value.formatter,
            L.value,
            r(N)({
              p: e.value.style.chart.layout.labels.hollow.total.value.prefix,
              v: L.value,
              s: e.value.style.chart.layout.labels.hollow.total.value.suffix
            })
          )), 13, El)) : i("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (u(), n("text", {
            key: 2,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.fontSize,
            style: _(`font-weight:${e.value.style.chart.layout.labels.hollow.average.bold ? "bold" : ""}`)
          }, P(e.value.style.chart.layout.labels.hollow.average.text), 13, Hl)) : i("", !0),
          e.value.style.chart.layout.labels.hollow.average.show ? (u(), n("text", {
            key: 3,
            "text-anchor": "middle",
            x: s.value.width / 2,
            y: s.value.height / 2 + (e.value.style.chart.layout.labels.hollow.total.show ? e.value.style.chart.layout.labels.hollow.average.fontSize : 0) + e.value.style.chart.layout.labels.hollow.average.fontSize + e.value.style.chart.layout.labels.hollow.average.value.offsetY,
            fill: e.value.style.chart.layout.labels.hollow.average.value.color,
            "font-size": e.value.style.chart.layout.labels.hollow.average.value.fontSize,
            style: _(`font-weight:${e.value.style.chart.layout.labels.hollow.average.value.bold ? "bold" : ""}`)
          }, P(W.value || Y.value ? "--" : r(M)(
            e.value.style.chart.layout.labels.hollow.average.value.formatter,
            Ge.value,
            r(N)({
              p: e.value.style.chart.layout.labels.hollow.average.value.prefix,
              v: Ge.value,
              s: e.value.style.chart.layout.labels.hollow.average.value.suffix,
              r: e.value.style.chart.layout.labels.hollow.average.value.rounding
            })
          )), 13, ql)) : i("", !0)
        ], 64)) : i("", !0),
        (u(!0), n(m, null, T(X.value.filter((t) => !t.ghost), (t, a) => (u(), n("g", {
          filter: j(a),
          class: pe({ animated: e.value.useCssAnimation })
        }, [
          e.value.style.chart.layout.labels.dataLabels.useLabelSlots ? (u(), n("g", Kl, [
            (u(), n("foreignObject", {
              x: r(w)(t, !0).anchor === "end" ? r(w)(t).x - 120 : r(w)(t, !0).anchor === "middle" ? r(w)(t).x - 60 : r(w)(t).x,
              y: r(ue)(t) - (je.value ? 20 : 0),
              width: "120",
              height: "60",
              style: { overflow: "visible" }
            }, [
              f("div", null, [
                g(l.$slots, "dataLabel", tt({ ref_for: !0 }, {
                  datapoint: t,
                  isBlur: !e.value.useBlurOnHover || [null, void 0].includes(F.value) || F.value === a,
                  isSafari: je.value,
                  isVisible: I(t) && h.value.dataLabels.show,
                  textAlign: r(w)(t, !0, 16, !0).anchor,
                  flexAlign: r(w)(t, !0, 16).anchor,
                  percentage: he(t, X.value)
                }), void 0, !0)
              ])
            ], 8, Ql))
          ])) : (u(), n("g", Zl, [
            e.value.type === "classic" ? (u(), n(m, { key: 0 }, [
              I(t) && h.value.dataLabels.show ? (u(), n("circle", {
                key: 0,
                cx: r(w)(t).x,
                cy: r(ue)(t) - 3.5,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(F.value) || F.value === a ? "" : `url(#blur_${y.value})`,
                onClick: (v) => U(t, a)
              }, null, 8, ea)) : i("", !0)
            ], 64)) : i("", !0),
            e.value.type === "polar" ? (u(), n(m, { key: 1 }, [
              I(t) && h.value.dataLabels.show ? (u(), n("circle", {
                key: 0,
                cx: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
                cy: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 24, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y,
                fill: t.color,
                stroke: e.value.style.chart.backgroundColor,
                "stroke-width": 1,
                r: 3,
                filter: !e.value.useBlurOnHover || [null, void 0].includes(F.value) || F.value === a ? "" : `url(#blur_${y.value})`,
                onClick: (v) => U(t, a)
              }, null, 8, ta)) : i("", !0)
            ], 64)) : i("", !0),
            e.value.type === "classic" ? (u(), n(m, { key: 2 }, [
              I(t) && h.value.dataLabels.show ? (u(), n("text", {
                key: 0,
                "text-anchor": r(w)(t, !0, 12).anchor,
                x: r(w)(t, !0, 12).x,
                y: r(ue)(t),
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: _(`font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (v) => U(t, a)
              }, P(he(t, X.value)) + " " + P(e.value.style.chart.layout.labels.value.show ? `(${r(M)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                r(N)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, la)) : i("", !0),
              I(t) && h.value.dataLabels.show ? (u(), n("text", {
                key: 1,
                "text-anchor": r(w)(t).anchor,
                x: r(w)(t, !0, 12).x,
                y: r(ue)(t) + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: _(`font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (v) => U(t, a)
              }, P(t.name), 13, aa)) : i("", !0)
            ], 64)) : i("", !0),
            e.value.type === "polar" ? (u(), n(m, { key: 3 }, [
              I(t) && h.value.dataLabels.show ? (u(), n("text", {
                key: 0,
                "text-anchor": J(c.value[a].middlePoint),
                x: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
                y: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y,
                fill: e.value.style.chart.layout.labels.percentage.color,
                "font-size": e.value.style.chart.layout.labels.percentage.fontSize,
                style: _(`transition: all 0.1s ease-in-out; font-weight:${e.value.style.chart.layout.labels.percentage.bold ? "bold" : ""}`),
                onClick: (v) => U(t, a)
              }, P(he(t, X.value)) + " " + P(e.value.style.chart.layout.labels.value.show ? `(${r(M)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                r(N)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                }),
                { datapoint: t }
              )})` : ""), 13, oa)) : i("", !0),
              I(t) && h.value.dataLabels.show ? (u(), n("text", {
                key: 1,
                "text-anchor": J(c.value[a].middlePoint),
                x: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x,
                y: r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).y + e.value.style.chart.layout.labels.percentage.fontSize,
                fill: e.value.style.chart.layout.labels.name.color,
                "font-size": e.value.style.chart.layout.labels.name.fontSize,
                style: _(`transition: all 0.1s ease-in-out; font-weight:${e.value.style.chart.layout.labels.name.bold ? "bold" : ""}`),
                onClick: (v) => U(t, a)
              }, P(t.name), 13, ua)) : i("", !0)
            ], 64)) : i("", !0)
          ])),
          h.value.dataLabels.show && e.value.style.chart.comments.show && t.comment ? (u(), n("g", sa, [
            I(t) && e.value.type === "classic" ? (u(), n("foreignObject", {
              key: 0,
              x: e.value.style.chart.comments.offsetX + (r(w)(t, !0).anchor === "end" ? r(w)(t).x - e.value.style.chart.comments.width : r(w)(t, !0).anchor === "middle" ? r(w)(t).x - e.value.style.chart.comments.width / 2 : r(w)(t).x),
              y: r(ue)(t) + 24 + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              f("div", null, [
                g(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: r(w)(t, !0, 16, !0).anchor, flexAlign: r(w)(t, !0, 16).anchor, isFirstLoad: Y.value }
                }, void 0, !0)
              ])
            ], 8, na)) : i("", !0),
            I(t) && e.value.type === "polar" ? (u(), n("foreignObject", {
              key: 1,
              x: e.value.style.chart.comments.offsetX + (J(c.value[a].middlePoint) === "end" ? r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x - e.value.style.chart.comments.width : J(c.value[a].middlePoint) === "middle" ? r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x - e.value.style.chart.comments.width / 2 : r(z)({ initX: c.value[a].middlePoint.x, initY: c.value[a].middlePoint.y, offset: 42, centerX: s.value.width / 2, centerY: s.value.height / 2 }).x),
              y: gt(c.value[a]) + e.value.style.chart.comments.offsetY,
              width: e.value.style.chart.comments.width,
              height: "200",
              style: { overflow: "visible", "pointer-events": "none" }
            }, [
              f("div", null, [
                g(l.$slots, "plot-comment", {
                  plot: { ...t, textAlign: J(c.value[a].middlePoint), flexAlign: J(c.value[a].middlePoint), isFirstLoad: Y.value }
                }, void 0, !0)
              ])
            ], 8, ra)) : i("", !0)
          ])) : i("", !0)
        ], 10, Jl))), 256)),
        g(l.$slots, "svg", { svg: s.value }, void 0, !0)
      ], 14, ol)) : i("", !0),
      l.$slots.watermark ? (u(), n("div", ia, [
        g(l.$slots, "watermark", Q(Z({ isPrinting: r(Ae) || r(Oe) })), void 0, !0)
      ])) : i("", !0),
      ee.value ? i("", !0) : (u(), E(qt, {
        key: 6,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC",
              strokeWidth: q.value * 0.8
            }
          }
        }
      }, null, 8, ["config"])),
      f("div", {
        ref_key: "chartLegend",
        ref: we
      }, [
        e.value.style.chart.legend.show ? (u(), E(Ht, {
          key: `legend_${Ce.value}`,
          legendSet: Be.value,
          config: pt.value,
          onClickMarker: o[4] || (o[4] = ({ i: t }) => Ve(t))
        }, et({
          item: $(({ legend: t, index: a }) => [
            f("div", {
              style: _(`opacity:${D.value.includes(a) ? 0.5 : 1}`),
              onClick: (v) => t.segregate()
            }, [
              lt(P(t.name) + ": " + P(r(M)(
                e.value.style.chart.layout.labels.value.formatter,
                t.value,
                r(N)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                {
                  datapoint: t,
                  index: a
                }
              )) + " ", 1),
              D.value.includes(a) ? (u(), n("span", da, " ( " + P(wt(t.proportion * 100)) + " % ) ", 1)) : (u(), n("span", ca, " (" + P(isNaN(t.value / L.value) ? "-" : r(M)(
                e.value.style.chart.layout.labels.percentage.formatter,
                Re.value(t),
                r(N)({
                  v: Re.value(t),
                  s: "%",
                  r: e.value.style.chart.legend.roundingPercentage
                })
              )) + ") ", 1))
            ], 12, va)
          ]),
          _: 2
        }, [
          l.$slots.pattern ? {
            name: "legend-pattern",
            fn: $(({ legend: t, index: a }) => [
              ge(el, {
                shape: t.shape,
                radius: 30,
                stroke: "none",
                plot: { x: 30, y: 30 },
                fill: `url(#pattern_${y.value}_${a})`
              }, null, 8, ["shape", "fill"])
            ]),
            key: "0"
          } : void 0
        ]), 1032, ["legendSet", "config"])) : i("", !0),
        g(l.$slots, "legend", { legend: Be.value }, void 0, !0)
      ], 512),
      l.$slots.source ? (u(), n("div", {
        key: 7,
        ref_key: "source",
        ref: ke,
        dir: "auto"
      }, [
        g(l.$slots, "source", {}, void 0, !0)
      ], 512)) : i("", !0),
      ge(Et, {
        show: h.value.showTooltip && ne.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: te.value,
        content: ve.value,
        isCustom: le.value,
        isFullscreen: K.value
      }, {
        "tooltip-before": $(() => [
          g(l.$slots, "tooltip-before", Q(Z({ ...ye.value })), void 0, !0)
        ]),
        "tooltip-after": $(() => [
          g(l.$slots, "tooltip-after", Q(Z({ ...ye.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom", "isFullscreen"]),
      ee.value ? (u(), E(Jt, {
        key: 8,
        hideDetails: "",
        config: {
          open: h.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: $(() => [
          (u(), E(jt, {
            key: `table_${$e.value}`,
            colNames: re.value.colNames,
            head: re.value.head,
            body: re.value.body,
            config: re.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[5] || (o[5] = (t) => h.value.showTable = !1)
          }, {
            th: $(({ th: t }) => [
              f("div", {
                innerHTML: t,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, ha)
            ]),
            td: $(({ td: t }) => [
              lt(P(t.name ? t.name : isNaN(Number(t)) ? t.includes("%") ? t : r(M)(
                e.value.style.chart.layout.labels.percentage.formatter,
                t,
                r(N)({
                  v: t,
                  s: "%",
                  r: e.value.style.chart.layout.labels.percentage.rounding
                })
              ) : r(M)(
                e.value.style.chart.layout.labels.value.formatter,
                t,
                r(N)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: t,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.value.rounding
                })
              )), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : i("", !0)
    ], 46, al));
  }
}, Aa = /* @__PURE__ */ ll(ya, [["__scopeId", "data-v-9e4a77ed"]]);
export {
  Aa as default
};
